package com.jboss.sample;

import javax.persistence.*;
import java.util.Date;

/**
 * @author Sebastian Hennebrueder
 */

@Entity
public class Sender {
	@Id
	@GeneratedValue
	private Long id;

	@Column(nullable = false, name = "column_name")
	private String name;

	// TODO 2)
	@Temporal(TemporalType.DATE)
	private Date birthday;

	// TODO 2)
	@Enumerated
	private Sex sex;

	// TODO 3)
//	@Transient
	private Address address;

	protected Sender() {
	}

	public Sender(String name) {
		this.name = name;
	}

	public Sender(String name, Address address) {
		this.name = name;
		this.address = address;
	}

	public Sender(String name, Date birthday, Sex sex) {
		this.name = name;
		this.birthday = birthday;
		this.sex = sex;
	}

	public Long getId() {
		return id;
	}

	public void setId(Long id) {
		this.id = id;
	}

	public String getName() {
		return name;
	}

	public void setName(String name) {
		this.name = name;
	}

	public Date getBirthday() {
		return birthday;
	}

	public void setBirthday(Date birthday) {
		this.birthday = birthday;
	}

	public Address getAddress() {
		return address;
	}

	public void setAddress(Address address) {
		this.address = address;
	}

	public Sex getSex() {
		return sex;
	}

	public void setSex(Sex sex) {
		this.sex = sex;
	}

	@Override
	public String toString() {
		final StringBuilder sb = new StringBuilder();
		sb.append("Sender");
		sb.append("{id=").append(id);
		sb.append(", name='").append(name).append('\'');
		sb.append('}');
		return sb.toString();
	}
}
