package com.jboss.sample;

import javax.persistence.*;

/**
 * @author Sebastian Hennebrueder
 */
@Entity
@Table(name = "messages")
public class Message {
	@Id
	@GeneratedValue
	private Long id;

	@Column(nullable = false)
	private String text;

	// TODO 4
	//@Transient
	@ManyToOne(cascade = {CascadeType.MERGE, CascadeType.PERSIST})
	@JoinColumn(name = "message_sender_id")
	private Sender sender;

	protected Message() {
	}

	public Message(String text, Sender sender) {
		this.text = text;
		this.sender = sender;
	}

	public Long getId() {
		return id;
	}

	public void setId(Long id) {
		this.id = id;
	}

	public String getText() {
		return text;
	}

	public void setText(String text) {
		this.text = text;
	}

	public Sender getSender() {
		return sender;
	}

	public void setSender(Sender sender) {
		this.sender = sender;
	}

	@Override
	public String toString() {
		final StringBuilder sb = new StringBuilder();
		sb.append("Message");
		sb.append("{id=").append(id);
		sb.append(", text='").append(text).append('\'');
		sb.append('}');
		return sb.toString();
	}
}

