package auction.model;

// Generated 15.03.2011 22:15:14 by Hibernate Tools 3.4.0.CR1

import java.util.HashSet;
import java.util.Set;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.OneToMany;
import javax.persistence.OneToOne;
import javax.persistence.PrimaryKeyJoinColumn;
import javax.persistence.Table;
import org.hibernate.annotations.GenericGenerator;
import org.hibernate.annotations.Parameter;

/**
 * Address generated by hbm2java
 */
@Entity
@Table(name = "ADDRESS", schema = "PUBLIC")
public class Address implements java.io.Serializable {

	private long addressId;
	private Users users;
	private String city;
	private String street;
	private Integer objVersion;
	private String zipcode;
	private Set<Shipment> shipments = new HashSet<Shipment>(0);

	public Address() {
	}

	public Address(Users users, String city, String street, String zipcode) {
		this.users = users;
		this.city = city;
		this.street = street;
		this.zipcode = zipcode;
	}

	public Address(Users users, String city, String street, Integer objVersion,
			String zipcode, Set<Shipment> shipments) {
		this.users = users;
		this.city = city;
		this.street = street;
		this.objVersion = objVersion;
		this.zipcode = zipcode;
		this.shipments = shipments;
	}

	@GenericGenerator(name = "generator", strategy = "foreign", parameters = @Parameter(name = "property", value = "users"))
	@Id
	@GeneratedValue(generator = "generator")
	@Column(name = "ADDRESS_ID", unique = true, nullable = false)
	public long getAddressId() {
		return this.addressId;
	}

	public void setAddressId(long addressId) {
		this.addressId = addressId;
	}

	@OneToOne(fetch = FetchType.LAZY)
	@PrimaryKeyJoinColumn
	public Users getUsers() {
		return this.users;
	}

	public void setUsers(Users users) {
		this.users = users;
	}

	@Column(name = "CITY", nullable = false)
	public String getCity() {
		return this.city;
	}

	public void setCity(String city) {
		this.city = city;
	}

	@Column(name = "STREET", nullable = false)
	public String getStreet() {
		return this.street;
	}

	public void setStreet(String street) {
		this.street = street;
	}

	@Column(name = "OBJ_VERSION")
	public Integer getObjVersion() {
		return this.objVersion;
	}

	public void setObjVersion(Integer objVersion) {
		this.objVersion = objVersion;
	}

	@Column(name = "ZIPCODE", nullable = false, length = 16)
	public String getZipcode() {
		return this.zipcode;
	}

	public void setZipcode(String zipcode) {
		this.zipcode = zipcode;
	}

	@OneToMany(fetch = FetchType.LAZY, mappedBy = "address")
	public Set<Shipment> getShipments() {
		return this.shipments;
	}

	public void setShipments(Set<Shipment> shipments) {
		this.shipments = shipments;
	}

}
