package auction.model;

// Generated 15.03.2011 22:15:14 by Hibernate Tools 3.4.0.CR1

import java.math.BigDecimal;
import java.util.Date;
import java.util.HashSet;
import java.util.Set;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import static javax.persistence.GenerationType.IDENTITY;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.OneToMany;
import javax.persistence.Table;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;

/**
 * Bid generated by hbm2java
 */
@Entity
@Table(name = "BID", schema = "PUBLIC")
public class Bid implements java.io.Serializable {

	private Long bidId;
	private Users users;
	private Item item;
	private BigDecimal bidAmount;
	private String bidAmountCurrency;
	private Date created;
	private boolean successful;
	private Integer bidPosition;
	private Set<Item> items = new HashSet<Item>(0);

	public Bid() {
	}

	public Bid(Users users, Item item, Date created, boolean successful) {
		this.users = users;
		this.item = item;
		this.created = created;
		this.successful = successful;
	}

	public Bid(Users users, Item item, BigDecimal bidAmount,
			String bidAmountCurrency, Date created, boolean successful,
			Integer bidPosition, Set<Item> items) {
		this.users = users;
		this.item = item;
		this.bidAmount = bidAmount;
		this.bidAmountCurrency = bidAmountCurrency;
		this.created = created;
		this.successful = successful;
		this.bidPosition = bidPosition;
		this.items = items;
	}

	@Id
	@GeneratedValue(strategy = IDENTITY)
	@Column(name = "BID_ID", unique = true, nullable = false)
	public Long getBidId() {
		return this.bidId;
	}

	public void setBidId(Long bidId) {
		this.bidId = bidId;
	}

	@ManyToOne(fetch = FetchType.LAZY)
	@JoinColumn(name = "BIDDER_ID", nullable = false)
	public Users getUsers() {
		return this.users;
	}

	public void setUsers(Users users) {
		this.users = users;
	}

	@ManyToOne(fetch = FetchType.LAZY)
	@JoinColumn(name = "ITEM_ID", nullable = false)
	public Item getItem() {
		return this.item;
	}

	public void setItem(Item item) {
		this.item = item;
	}

	@Column(name = "BID_AMOUNT", precision = 646456993, scale = 0)
	public BigDecimal getBidAmount() {
		return this.bidAmount;
	}

	public void setBidAmount(BigDecimal bidAmount) {
		this.bidAmount = bidAmount;
	}

	@Column(name = "BID_AMOUNT_CURRENCY", length = 3)
	public String getBidAmountCurrency() {
		return this.bidAmountCurrency;
	}

	public void setBidAmountCurrency(String bidAmountCurrency) {
		this.bidAmountCurrency = bidAmountCurrency;
	}

	@Temporal(TemporalType.TIMESTAMP)
	@Column(name = "CREATED", nullable = false, length = 6)
	public Date getCreated() {
		return this.created;
	}

	public void setCreated(Date created) {
		this.created = created;
	}

	@Column(name = "SUCCESSFUL", nullable = false)
	public boolean isSuccessful() {
		return this.successful;
	}

	public void setSuccessful(boolean successful) {
		this.successful = successful;
	}

	@Column(name = "BID_POSITION")
	public Integer getBidPosition() {
		return this.bidPosition;
	}

	public void setBidPosition(Integer bidPosition) {
		this.bidPosition = bidPosition;
	}

	@OneToMany(fetch = FetchType.LAZY, mappedBy = "bid")
	public Set<Item> getItems() {
		return this.items;
	}

	public void setItems(Set<Item> items) {
		this.items = items;
	}

}
