package auction.model;

// Generated 15.03.2011 22:15:14 by Hibernate Tools 3.4.0.CR1

import java.util.Date;
import java.util.HashSet;
import java.util.Set;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import static javax.persistence.GenerationType.IDENTITY;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.OneToMany;
import javax.persistence.Table;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;
import javax.persistence.UniqueConstraint;

/**
 * Category generated by hbm2java
 */
@Entity
@Table(name = "CATEGORY", schema = "PUBLIC", uniqueConstraints = @UniqueConstraint(columnNames = {
		"CATEGORY_NAME", "PARENT_CATEGORY_ID" }))
public class Category implements java.io.Serializable {

	private Long categoryId;
	private Category category;
	private Date created;
	private String categoryName;
	private Integer objVersion;
	private Set<CategorizedItem> categorizedItems = new HashSet<CategorizedItem>(
			0);
	private Set<CategoryItem> categoryItems = new HashSet<CategoryItem>(0);
	private Set<CategoryItemsByUser> categoryItemsByUsers = new HashSet<CategoryItemsByUser>(
			0);
	private Set<CategorizedItemComponents> categorizedItemComponentses = new HashSet<CategorizedItemComponents>(
			0);
	private Set<Category> categories = new HashSet<Category>(0);

	public Category() {
	}

	public Category(Date created, String categoryName) {
		this.created = created;
		this.categoryName = categoryName;
	}

	public Category(Category category, Date created, String categoryName,
			Integer objVersion, Set<CategorizedItem> categorizedItems,
			Set<CategoryItem> categoryItems,
			Set<CategoryItemsByUser> categoryItemsByUsers,
			Set<CategorizedItemComponents> categorizedItemComponentses,
			Set<Category> categories) {
		this.category = category;
		this.created = created;
		this.categoryName = categoryName;
		this.objVersion = objVersion;
		this.categorizedItems = categorizedItems;
		this.categoryItems = categoryItems;
		this.categoryItemsByUsers = categoryItemsByUsers;
		this.categorizedItemComponentses = categorizedItemComponentses;
		this.categories = categories;
	}

	@Id
	@GeneratedValue(strategy = IDENTITY)
	@Column(name = "CATEGORY_ID", unique = true, nullable = false)
	public Long getCategoryId() {
		return this.categoryId;
	}

	public void setCategoryId(Long categoryId) {
		this.categoryId = categoryId;
	}

	@ManyToOne(fetch = FetchType.LAZY)
	@JoinColumn(name = "PARENT_CATEGORY_ID")
	public Category getCategory() {
		return this.category;
	}

	public void setCategory(Category category) {
		this.category = category;
	}

	@Temporal(TemporalType.TIMESTAMP)
	@Column(name = "CREATED", nullable = false, length = 6)
	public Date getCreated() {
		return this.created;
	}

	public void setCreated(Date created) {
		this.created = created;
	}

	@Column(name = "CATEGORY_NAME", nullable = false)
	public String getCategoryName() {
		return this.categoryName;
	}

	public void setCategoryName(String categoryName) {
		this.categoryName = categoryName;
	}

	@Column(name = "OBJ_VERSION")
	public Integer getObjVersion() {
		return this.objVersion;
	}

	public void setObjVersion(Integer objVersion) {
		this.objVersion = objVersion;
	}

	@OneToMany(fetch = FetchType.LAZY, mappedBy = "category")
	public Set<CategorizedItem> getCategorizedItems() {
		return this.categorizedItems;
	}

	public void setCategorizedItems(Set<CategorizedItem> categorizedItems) {
		this.categorizedItems = categorizedItems;
	}

	@OneToMany(fetch = FetchType.LAZY, mappedBy = "category")
	public Set<CategoryItem> getCategoryItems() {
		return this.categoryItems;
	}

	public void setCategoryItems(Set<CategoryItem> categoryItems) {
		this.categoryItems = categoryItems;
	}

	@OneToMany(fetch = FetchType.LAZY, mappedBy = "category")
	public Set<CategoryItemsByUser> getCategoryItemsByUsers() {
		return this.categoryItemsByUsers;
	}

	public void setCategoryItemsByUsers(
			Set<CategoryItemsByUser> categoryItemsByUsers) {
		this.categoryItemsByUsers = categoryItemsByUsers;
	}

	@OneToMany(fetch = FetchType.LAZY, mappedBy = "category")
	public Set<CategorizedItemComponents> getCategorizedItemComponentses() {
		return this.categorizedItemComponentses;
	}

	public void setCategorizedItemComponentses(
			Set<CategorizedItemComponents> categorizedItemComponentses) {
		this.categorizedItemComponentses = categorizedItemComponentses;
	}

	@OneToMany(fetch = FetchType.LAZY, mappedBy = "category")
	public Set<Category> getCategories() {
		return this.categories;
	}

	public void setCategories(Set<Category> categories) {
		this.categories = categories;
	}

}
