package auction.model;

// Generated 15.03.2011 22:15:14 by Hibernate Tools 3.4.0.CR1

import java.math.BigDecimal;
import java.util.Date;
import java.util.HashSet;
import java.util.Set;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import static javax.persistence.GenerationType.IDENTITY;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.OneToMany;
import javax.persistence.OneToOne;
import javax.persistence.Table;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;

/**
 * Item generated by hbm2java
 */
@Entity
@Table(name = "ITEM", schema = "PUBLIC")
public class Item implements java.io.Serializable {

	private Long itemId;
	private Users usersByApprovedByUserId;
	private Bid bid;
	private Users usersByItemBuyerFk;
	private Users usersBySellerId;
	private Date approvalDatetime;
	private Date created;
	private String description;
	private Date endDate;
	private BigDecimal initialPrice;
	private String initialPriceCurrency;
	private String itemName;
	private Date startDate;
	private String itemState;
	private Integer objVersion;
	private Set<CategorizedItem> categorizedItems = new HashSet<CategorizedItem>(
			0);
	private Set<ItemImages> itemImageses = new HashSet<ItemImages>(0);
	private ItemBuyer itemBuyer;
	private Set<Comment> comments = new HashSet<Comment>(0);
	private Set<CategoryItemsByUser> categoryItemsByUsers = new HashSet<CategoryItemsByUser>(
			0);
	private Set<CategoryItem> categoryItems = new HashSet<CategoryItem>(0);
	private Set<CategorizedItemComponents> categorizedItemComponentses = new HashSet<CategorizedItemComponents>(
			0);
	private Set<Bid> bids = new HashSet<Bid>(0);
	private Set<ItemShipment> itemShipments = new HashSet<ItemShipment>(0);

	public Item() {
	}

	public Item(Date created, String description, Date endDate,
			BigDecimal initialPrice, String initialPriceCurrency,
			String itemName, Date startDate, String itemState) {
		this.created = created;
		this.description = description;
		this.endDate = endDate;
		this.initialPrice = initialPrice;
		this.initialPriceCurrency = initialPriceCurrency;
		this.itemName = itemName;
		this.startDate = startDate;
		this.itemState = itemState;
	}

	public Item(Users usersByApprovedByUserId, Bid bid,
			Users usersByItemBuyerFk, Users usersBySellerId,
			Date approvalDatetime, Date created, String description,
			Date endDate, BigDecimal initialPrice, String initialPriceCurrency,
			String itemName, Date startDate, String itemState,
			Integer objVersion, Set<CategorizedItem> categorizedItems,
			Set<ItemImages> itemImageses, ItemBuyer itemBuyer,
			Set<Comment> comments,
			Set<CategoryItemsByUser> categoryItemsByUsers,
			Set<CategoryItem> categoryItems,
			Set<CategorizedItemComponents> categorizedItemComponentses,
			Set<Bid> bids, Set<ItemShipment> itemShipments) {
		this.usersByApprovedByUserId = usersByApprovedByUserId;
		this.bid = bid;
		this.usersByItemBuyerFk = usersByItemBuyerFk;
		this.usersBySellerId = usersBySellerId;
		this.approvalDatetime = approvalDatetime;
		this.created = created;
		this.description = description;
		this.endDate = endDate;
		this.initialPrice = initialPrice;
		this.initialPriceCurrency = initialPriceCurrency;
		this.itemName = itemName;
		this.startDate = startDate;
		this.itemState = itemState;
		this.objVersion = objVersion;
		this.categorizedItems = categorizedItems;
		this.itemImageses = itemImageses;
		this.itemBuyer = itemBuyer;
		this.comments = comments;
		this.categoryItemsByUsers = categoryItemsByUsers;
		this.categoryItems = categoryItems;
		this.categorizedItemComponentses = categorizedItemComponentses;
		this.bids = bids;
		this.itemShipments = itemShipments;
	}

	@Id
	@GeneratedValue(strategy = IDENTITY)
	@Column(name = "ITEM_ID", unique = true, nullable = false)
	public Long getItemId() {
		return this.itemId;
	}

	public void setItemId(Long itemId) {
		this.itemId = itemId;
	}

	@ManyToOne(fetch = FetchType.LAZY)
	@JoinColumn(name = "APPROVED_BY_USER_ID")
	public Users getUsersByApprovedByUserId() {
		return this.usersByApprovedByUserId;
	}

	public void setUsersByApprovedByUserId(Users usersByApprovedByUserId) {
		this.usersByApprovedByUserId = usersByApprovedByUserId;
	}

	@ManyToOne(fetch = FetchType.LAZY)
	@JoinColumn(name = "SUCCESSFUL_BID_ID")
	public Bid getBid() {
		return this.bid;
	}

	public void setBid(Bid bid) {
		this.bid = bid;
	}

	@ManyToOne(fetch = FetchType.LAZY)
	@JoinColumn(name = "ITEM_BUYER_FK")
	public Users getUsersByItemBuyerFk() {
		return this.usersByItemBuyerFk;
	}

	public void setUsersByItemBuyerFk(Users usersByItemBuyerFk) {
		this.usersByItemBuyerFk = usersByItemBuyerFk;
	}

	@ManyToOne(fetch = FetchType.LAZY)
	@JoinColumn(name = "SELLER_ID")
	public Users getUsersBySellerId() {
		return this.usersBySellerId;
	}

	public void setUsersBySellerId(Users usersBySellerId) {
		this.usersBySellerId = usersBySellerId;
	}

	@Temporal(TemporalType.TIMESTAMP)
	@Column(name = "APPROVAL_DATETIME", length = 6)
	public Date getApprovalDatetime() {
		return this.approvalDatetime;
	}

	public void setApprovalDatetime(Date approvalDatetime) {
		this.approvalDatetime = approvalDatetime;
	}

	@Temporal(TemporalType.TIMESTAMP)
	@Column(name = "CREATED", nullable = false, length = 6)
	public Date getCreated() {
		return this.created;
	}

	public void setCreated(Date created) {
		this.created = created;
	}

	@Column(name = "DESCRIPTION", nullable = false, length = 4000)
	public String getDescription() {
		return this.description;
	}

	public void setDescription(String description) {
		this.description = description;
	}

	@Temporal(TemporalType.TIMESTAMP)
	@Column(name = "END_DATE", nullable = false, length = 6)
	public Date getEndDate() {
		return this.endDate;
	}

	public void setEndDate(Date endDate) {
		this.endDate = endDate;
	}

	@Column(name = "INITIAL_PRICE", nullable = false, precision = 646456993, scale = 0)
	public BigDecimal getInitialPrice() {
		return this.initialPrice;
	}

	public void setInitialPrice(BigDecimal initialPrice) {
		this.initialPrice = initialPrice;
	}

	@Column(name = "INITIAL_PRICE_CURRENCY", nullable = false, length = 3)
	public String getInitialPriceCurrency() {
		return this.initialPriceCurrency;
	}

	public void setInitialPriceCurrency(String initialPriceCurrency) {
		this.initialPriceCurrency = initialPriceCurrency;
	}

	@Column(name = "ITEM_NAME", nullable = false)
	public String getItemName() {
		return this.itemName;
	}

	public void setItemName(String itemName) {
		this.itemName = itemName;
	}

	@Temporal(TemporalType.TIMESTAMP)
	@Column(name = "START_DATE", nullable = false, length = 6)
	public Date getStartDate() {
		return this.startDate;
	}

	public void setStartDate(Date startDate) {
		this.startDate = startDate;
	}

	@Column(name = "ITEM_STATE", nullable = false)
	public String getItemState() {
		return this.itemState;
	}

	public void setItemState(String itemState) {
		this.itemState = itemState;
	}

	@Column(name = "OBJ_VERSION")
	public Integer getObjVersion() {
		return this.objVersion;
	}

	public void setObjVersion(Integer objVersion) {
		this.objVersion = objVersion;
	}

	@OneToMany(fetch = FetchType.LAZY, mappedBy = "item")
	public Set<CategorizedItem> getCategorizedItems() {
		return this.categorizedItems;
	}

	public void setCategorizedItems(Set<CategorizedItem> categorizedItems) {
		this.categorizedItems = categorizedItems;
	}

	@OneToMany(fetch = FetchType.LAZY, mappedBy = "item")
	public Set<ItemImages> getItemImageses() {
		return this.itemImageses;
	}

	public void setItemImageses(Set<ItemImages> itemImageses) {
		this.itemImageses = itemImageses;
	}

	@OneToOne(fetch = FetchType.LAZY, mappedBy = "item")
	public ItemBuyer getItemBuyer() {
		return this.itemBuyer;
	}

	public void setItemBuyer(ItemBuyer itemBuyer) {
		this.itemBuyer = itemBuyer;
	}

	@OneToMany(fetch = FetchType.LAZY, mappedBy = "item")
	public Set<Comment> getComments() {
		return this.comments;
	}

	public void setComments(Set<Comment> comments) {
		this.comments = comments;
	}

	@OneToMany(fetch = FetchType.LAZY, mappedBy = "item")
	public Set<CategoryItemsByUser> getCategoryItemsByUsers() {
		return this.categoryItemsByUsers;
	}

	public void setCategoryItemsByUsers(
			Set<CategoryItemsByUser> categoryItemsByUsers) {
		this.categoryItemsByUsers = categoryItemsByUsers;
	}

	@OneToMany(fetch = FetchType.LAZY, mappedBy = "item")
	public Set<CategoryItem> getCategoryItems() {
		return this.categoryItems;
	}

	public void setCategoryItems(Set<CategoryItem> categoryItems) {
		this.categoryItems = categoryItems;
	}

	@OneToMany(fetch = FetchType.LAZY, mappedBy = "item")
	public Set<CategorizedItemComponents> getCategorizedItemComponentses() {
		return this.categorizedItemComponentses;
	}

	public void setCategorizedItemComponentses(
			Set<CategorizedItemComponents> categorizedItemComponentses) {
		this.categorizedItemComponentses = categorizedItemComponentses;
	}

	@OneToMany(fetch = FetchType.LAZY, mappedBy = "item")
	public Set<Bid> getBids() {
		return this.bids;
	}

	public void setBids(Set<Bid> bids) {
		this.bids = bids;
	}

	@OneToMany(fetch = FetchType.LAZY, mappedBy = "item")
	public Set<ItemShipment> getItemShipments() {
		return this.itemShipments;
	}

	public void setItemShipments(Set<ItemShipment> itemShipments) {
		this.itemShipments = itemShipments;
	}

}
