package auction.model;

// Generated 15.03.2011 22:15:14 by Hibernate Tools 3.4.0.CR1

import java.util.Date;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import static javax.persistence.GenerationType.IDENTITY;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.OneToOne;
import javax.persistence.Table;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;

/**
 * Shipment generated by hbm2java
 */
@Entity
@Table(name = "SHIPMENT", schema = "PUBLIC")
public class Shipment implements java.io.Serializable {

	private Long shipmentId;
	private Address address;
	private Users usersByBuyerId;
	private Users usersBySellerId;
	private Date created;
	private int inspectionPeriodDays;
	private String shipmentState;
	private Integer objVersion;
	private ItemShipment itemShipment;

	public Shipment() {
	}

	public Shipment(Address address, Users usersByBuyerId,
			Users usersBySellerId, Date created, int inspectionPeriodDays,
			String shipmentState) {
		this.address = address;
		this.usersByBuyerId = usersByBuyerId;
		this.usersBySellerId = usersBySellerId;
		this.created = created;
		this.inspectionPeriodDays = inspectionPeriodDays;
		this.shipmentState = shipmentState;
	}

	public Shipment(Address address, Users usersByBuyerId,
			Users usersBySellerId, Date created, int inspectionPeriodDays,
			String shipmentState, Integer objVersion, ItemShipment itemShipment) {
		this.address = address;
		this.usersByBuyerId = usersByBuyerId;
		this.usersBySellerId = usersBySellerId;
		this.created = created;
		this.inspectionPeriodDays = inspectionPeriodDays;
		this.shipmentState = shipmentState;
		this.objVersion = objVersion;
		this.itemShipment = itemShipment;
	}

	@Id
	@GeneratedValue(strategy = IDENTITY)
	@Column(name = "SHIPMENT_ID", unique = true, nullable = false)
	public Long getShipmentId() {
		return this.shipmentId;
	}

	public void setShipmentId(Long shipmentId) {
		this.shipmentId = shipmentId;
	}

	@ManyToOne(fetch = FetchType.LAZY)
	@JoinColumn(name = "DELIVERY_ADDRESS_ID", nullable = false)
	public Address getAddress() {
		return this.address;
	}

	public void setAddress(Address address) {
		this.address = address;
	}

	@ManyToOne(fetch = FetchType.LAZY)
	@JoinColumn(name = "BUYER_ID", nullable = false)
	public Users getUsersByBuyerId() {
		return this.usersByBuyerId;
	}

	public void setUsersByBuyerId(Users usersByBuyerId) {
		this.usersByBuyerId = usersByBuyerId;
	}

	@ManyToOne(fetch = FetchType.LAZY)
	@JoinColumn(name = "SELLER_ID", nullable = false)
	public Users getUsersBySellerId() {
		return this.usersBySellerId;
	}

	public void setUsersBySellerId(Users usersBySellerId) {
		this.usersBySellerId = usersBySellerId;
	}

	@Temporal(TemporalType.TIMESTAMP)
	@Column(name = "CREATED", nullable = false, length = 6)
	public Date getCreated() {
		return this.created;
	}

	public void setCreated(Date created) {
		this.created = created;
	}

	@Column(name = "INSPECTION_PERIOD_DAYS", nullable = false)
	public int getInspectionPeriodDays() {
		return this.inspectionPeriodDays;
	}

	public void setInspectionPeriodDays(int inspectionPeriodDays) {
		this.inspectionPeriodDays = inspectionPeriodDays;
	}

	@Column(name = "SHIPMENT_STATE", nullable = false)
	public String getShipmentState() {
		return this.shipmentState;
	}

	public void setShipmentState(String shipmentState) {
		this.shipmentState = shipmentState;
	}

	@Column(name = "OBJ_VERSION")
	public Integer getObjVersion() {
		return this.objVersion;
	}

	public void setObjVersion(Integer objVersion) {
		this.objVersion = objVersion;
	}

	@OneToOne(fetch = FetchType.LAZY, mappedBy = "shipment")
	public ItemShipment getItemShipment() {
		return this.itemShipment;
	}

	public void setItemShipment(ItemShipment itemShipment) {
		this.itemShipment = itemShipment;
	}

}
