package auction.model;

// Generated 15.03.2011 22:15:14 by Hibernate Tools 3.4.0.CR1

import java.util.Date;
import java.util.HashSet;
import java.util.Set;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import static javax.persistence.GenerationType.IDENTITY;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.OneToMany;
import javax.persistence.OneToOne;
import javax.persistence.Table;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;
import javax.persistence.UniqueConstraint;

/**
 * Users generated by hbm2java
 */
@Entity
@Table(name = "USERS", schema = "PUBLIC", uniqueConstraints = @UniqueConstraint(columnNames = "USERNAME"))
public class Users implements java.io.Serializable {

	private Long userId;
	private BillingDetails billingDetails;
	private boolean isAdmin;
	private String billingCity;
	private String billingStreet;
	private String billingZipcode;
	private Date created;
	private String email;
	private String firstname;
	private String homeCity;
	private String homeStreet;
	private String homeZipcode;
	private String lastname;
	private String password;
	private int rank;
	private String username;
	private Integer objVersion;
	private Set<ItemBuyer> itemBuyers = new HashSet<ItemBuyer>(0);
	private Set<Comment> comments = new HashSet<Comment>(0);
	private Set<Shipment> shipmentsForBuyerId = new HashSet<Shipment>(0);
	private BillingAddress billingAddress;
	private Set<Item> itemsForItemBuyerFk = new HashSet<Item>(0);
	private Set<BillingDetails> billingDetailses = new HashSet<BillingDetails>(
			0);
	private Set<CategoryItemsByUser> categoryItemsByUsers = new HashSet<CategoryItemsByUser>(
			0);
	private Set<Bid> bids = new HashSet<Bid>(0);
	private Address address;
	private Set<Shipment> shipmentsForSellerId = new HashSet<Shipment>(0);
	private Set<Item> itemsForApprovedByUserId = new HashSet<Item>(0);
	private Set<Item> itemsForSellerId = new HashSet<Item>(0);

	public Users() {
	}

	public Users(boolean isAdmin, Date created, String email, String firstname,
			String lastname, String password, int rank, String username) {
		this.isAdmin = isAdmin;
		this.created = created;
		this.email = email;
		this.firstname = firstname;
		this.lastname = lastname;
		this.password = password;
		this.rank = rank;
		this.username = username;
	}

	public Users(BillingDetails billingDetails, boolean isAdmin,
			String billingCity, String billingStreet, String billingZipcode,
			Date created, String email, String firstname, String homeCity,
			String homeStreet, String homeZipcode, String lastname,
			String password, int rank, String username, Integer objVersion,
			Set<ItemBuyer> itemBuyers, Set<Comment> comments,
			Set<Shipment> shipmentsForBuyerId, BillingAddress billingAddress,
			Set<Item> itemsForItemBuyerFk,
			Set<BillingDetails> billingDetailses,
			Set<CategoryItemsByUser> categoryItemsByUsers, Set<Bid> bids,
			Address address, Set<Shipment> shipmentsForSellerId,
			Set<Item> itemsForApprovedByUserId, Set<Item> itemsForSellerId) {
		this.billingDetails = billingDetails;
		this.isAdmin = isAdmin;
		this.billingCity = billingCity;
		this.billingStreet = billingStreet;
		this.billingZipcode = billingZipcode;
		this.created = created;
		this.email = email;
		this.firstname = firstname;
		this.homeCity = homeCity;
		this.homeStreet = homeStreet;
		this.homeZipcode = homeZipcode;
		this.lastname = lastname;
		this.password = password;
		this.rank = rank;
		this.username = username;
		this.objVersion = objVersion;
		this.itemBuyers = itemBuyers;
		this.comments = comments;
		this.shipmentsForBuyerId = shipmentsForBuyerId;
		this.billingAddress = billingAddress;
		this.itemsForItemBuyerFk = itemsForItemBuyerFk;
		this.billingDetailses = billingDetailses;
		this.categoryItemsByUsers = categoryItemsByUsers;
		this.bids = bids;
		this.address = address;
		this.shipmentsForSellerId = shipmentsForSellerId;
		this.itemsForApprovedByUserId = itemsForApprovedByUserId;
		this.itemsForSellerId = itemsForSellerId;
	}

	@Id
	@GeneratedValue(strategy = IDENTITY)
	@Column(name = "USER_ID", unique = true, nullable = false)
	public Long getUserId() {
		return this.userId;
	}

	public void setUserId(Long userId) {
		this.userId = userId;
	}

	@ManyToOne(fetch = FetchType.LAZY)
	@JoinColumn(name = "DEFAULT_BILLING_DETAILS_ID")
	public BillingDetails getBillingDetails() {
		return this.billingDetails;
	}

	public void setBillingDetails(BillingDetails billingDetails) {
		this.billingDetails = billingDetails;
	}

	@Column(name = "IS_ADMIN", nullable = false)
	public boolean isIsAdmin() {
		return this.isAdmin;
	}

	public void setIsAdmin(boolean isAdmin) {
		this.isAdmin = isAdmin;
	}

	@Column(name = "BILLING_CITY")
	public String getBillingCity() {
		return this.billingCity;
	}

	public void setBillingCity(String billingCity) {
		this.billingCity = billingCity;
	}

	@Column(name = "BILLING_STREET")
	public String getBillingStreet() {
		return this.billingStreet;
	}

	public void setBillingStreet(String billingStreet) {
		this.billingStreet = billingStreet;
	}

	@Column(name = "BILLING_ZIPCODE", length = 16)
	public String getBillingZipcode() {
		return this.billingZipcode;
	}

	public void setBillingZipcode(String billingZipcode) {
		this.billingZipcode = billingZipcode;
	}

	@Temporal(TemporalType.TIMESTAMP)
	@Column(name = "CREATED", nullable = false, length = 6)
	public Date getCreated() {
		return this.created;
	}

	public void setCreated(Date created) {
		this.created = created;
	}

	@Column(name = "EMAIL", nullable = false)
	public String getEmail() {
		return this.email;
	}

	public void setEmail(String email) {
		this.email = email;
	}

	@Column(name = "FIRSTNAME", nullable = false)
	public String getFirstname() {
		return this.firstname;
	}

	public void setFirstname(String firstname) {
		this.firstname = firstname;
	}

	@Column(name = "HOME_CITY")
	public String getHomeCity() {
		return this.homeCity;
	}

	public void setHomeCity(String homeCity) {
		this.homeCity = homeCity;
	}

	@Column(name = "HOME_STREET")
	public String getHomeStreet() {
		return this.homeStreet;
	}

	public void setHomeStreet(String homeStreet) {
		this.homeStreet = homeStreet;
	}

	@Column(name = "HOME_ZIPCODE", length = 16)
	public String getHomeZipcode() {
		return this.homeZipcode;
	}

	public void setHomeZipcode(String homeZipcode) {
		this.homeZipcode = homeZipcode;
	}

	@Column(name = "LASTNAME", nullable = false)
	public String getLastname() {
		return this.lastname;
	}

	public void setLastname(String lastname) {
		this.lastname = lastname;
	}

	@Column(name = "PASSWORD", nullable = false, length = 12)
	public String getPassword() {
		return this.password;
	}

	public void setPassword(String password) {
		this.password = password;
	}

	@Column(name = "RANK", nullable = false)
	public int getRank() {
		return this.rank;
	}

	public void setRank(int rank) {
		this.rank = rank;
	}

	@Column(name = "USERNAME", unique = true, nullable = false, length = 16)
	public String getUsername() {
		return this.username;
	}

	public void setUsername(String username) {
		this.username = username;
	}

	@Column(name = "OBJ_VERSION")
	public Integer getObjVersion() {
		return this.objVersion;
	}

	public void setObjVersion(Integer objVersion) {
		this.objVersion = objVersion;
	}

	@OneToMany(fetch = FetchType.LAZY, mappedBy = "users")
	public Set<ItemBuyer> getItemBuyers() {
		return this.itemBuyers;
	}

	public void setItemBuyers(Set<ItemBuyer> itemBuyers) {
		this.itemBuyers = itemBuyers;
	}

	@OneToMany(fetch = FetchType.LAZY, mappedBy = "users")
	public Set<Comment> getComments() {
		return this.comments;
	}

	public void setComments(Set<Comment> comments) {
		this.comments = comments;
	}

	@OneToMany(fetch = FetchType.LAZY, mappedBy = "usersByBuyerId")
	public Set<Shipment> getShipmentsForBuyerId() {
		return this.shipmentsForBuyerId;
	}

	public void setShipmentsForBuyerId(Set<Shipment> shipmentsForBuyerId) {
		this.shipmentsForBuyerId = shipmentsForBuyerId;
	}

	@OneToOne(fetch = FetchType.LAZY, mappedBy = "users")
	public BillingAddress getBillingAddress() {
		return this.billingAddress;
	}

	public void setBillingAddress(BillingAddress billingAddress) {
		this.billingAddress = billingAddress;
	}

	@OneToMany(fetch = FetchType.LAZY, mappedBy = "usersByItemBuyerFk")
	public Set<Item> getItemsForItemBuyerFk() {
		return this.itemsForItemBuyerFk;
	}

	public void setItemsForItemBuyerFk(Set<Item> itemsForItemBuyerFk) {
		this.itemsForItemBuyerFk = itemsForItemBuyerFk;
	}

	@OneToMany(fetch = FetchType.LAZY, mappedBy = "users")
	public Set<BillingDetails> getBillingDetailses() {
		return this.billingDetailses;
	}

	public void setBillingDetailses(Set<BillingDetails> billingDetailses) {
		this.billingDetailses = billingDetailses;
	}

	@OneToMany(fetch = FetchType.LAZY, mappedBy = "users")
	public Set<CategoryItemsByUser> getCategoryItemsByUsers() {
		return this.categoryItemsByUsers;
	}

	public void setCategoryItemsByUsers(
			Set<CategoryItemsByUser> categoryItemsByUsers) {
		this.categoryItemsByUsers = categoryItemsByUsers;
	}

	@OneToMany(fetch = FetchType.LAZY, mappedBy = "users")
	public Set<Bid> getBids() {
		return this.bids;
	}

	public void setBids(Set<Bid> bids) {
		this.bids = bids;
	}

	@OneToOne(fetch = FetchType.LAZY, mappedBy = "users")
	public Address getAddress() {
		return this.address;
	}

	public void setAddress(Address address) {
		this.address = address;
	}

	@OneToMany(fetch = FetchType.LAZY, mappedBy = "usersBySellerId")
	public Set<Shipment> getShipmentsForSellerId() {
		return this.shipmentsForSellerId;
	}

	public void setShipmentsForSellerId(Set<Shipment> shipmentsForSellerId) {
		this.shipmentsForSellerId = shipmentsForSellerId;
	}

	@OneToMany(fetch = FetchType.LAZY, mappedBy = "usersByApprovedByUserId")
	public Set<Item> getItemsForApprovedByUserId() {
		return this.itemsForApprovedByUserId;
	}

	public void setItemsForApprovedByUserId(Set<Item> itemsForApprovedByUserId) {
		this.itemsForApprovedByUserId = itemsForApprovedByUserId;
	}

	@OneToMany(fetch = FetchType.LAZY, mappedBy = "usersBySellerId")
	public Set<Item> getItemsForSellerId() {
		return this.itemsForSellerId;
	}

	public void setItemsForSellerId(Set<Item> itemsForSellerId) {
		this.itemsForSellerId = itemsForSellerId;
	}

}
