package auction.service;

import auction.dao.UserDAO;
import auction.model.Users;
import com.jboss.transactions.Transactional;
import org.hibernate.Hibernate;

import javax.inject.Inject;
import java.util.List;

/**
 * @author Sebastian Hennebrueder
 */
public class UserServiceImpl implements UserService {
	private UserDAO userDAO;

	@Inject
	public UserServiceImpl(UserDAO userDAO) {
		this.userDAO = userDAO;
	}

	@Override @Transactional
	public Users findByName(String name) {
		return userDAO.findByName(name);
	}

	@Override @Transactional
	public Users findById(Long id, boolean lock) {
		return userDAO.findById(id, lock);
	}

	@Override @Transactional
	public Users findByIdInitializeItems(long id, boolean lock) {
		final Users user = userDAO.findById(id, lock);
		Hibernate.initialize(user.getItemsForSellerId());
		return user;
	}

	@Override @Transactional
	public List<Users> findAll() {
		return userDAO.findAll();
	}
}
