package auction.dao;

import auction.model.Category;

import java.util.List;

/**
 * {@link Category} specific data access object.
 *
 * @author Lamon Gray
 */
public class CategoryDAOImpl
        extends GenericDAOImpl<Category, Long>
        implements  CategoryDAO {

    @SuppressWarnings("unchecked")
    public List<Category> findAll(boolean onlyRootCategories) {
        if (onlyRootCategories)
            return em.createQuery("select c from " + getEntityBeanType().getName() + " c" +
								" where c.parentCategory is null").getResultList();
            // Or bind ourself to a Hibernate extension and use findByCriteria(Criterion...) from superclass?
        else
            return findAll();
    } 

}
