package auction.dao;

import auction.model.Bid;
import auction.model.Item;

import java.util.List;

/**
 * {@link Item } specific data access object.
 *
 * @author Lamon Gray
 */
public class ItemDAOImpl extends GenericDAOImpl<Item, Long> implements ItemDAO {

	public Bid getMaxBid(Item item) {
		Bid currentMaxBid = null;
		List<?> result = em
				.createNamedQuery("Item-getMaxBid")
				.setParameter("itemId", item.getId())
				.getResultList();
		if (result.size() > 0) currentMaxBid = (Bid) result.get(0);
		return currentMaxBid;
	}

	public Bid getMinBid(Item item) {
		Bid currentMinBid = null;
		List<?> result = em
				.createNamedQuery("Item-getMinBid")
				.setParameter("itemId", item.getId())
				.getResultList();
		if (result.size() > 0) currentMinBid = (Bid) result.get(0);
		return currentMinBid;
	}

	public Item fetchWithBids(Item item) {
		return (Item) em
				.createQuery("select i from Item i left join fetch i.bids where i = :item")
				.setParameter("item", item)
				.getSingleResult();
	}

}
