package auction.dao;


import auction.model.User;

import java.util.List;

/**
 * {@link User} specific data access object.
 *
 * @author Lamon Gray
 */
public class UserDAOImpl extends GenericDAOImpl<User, Long> implements UserDAO {

	@Override
	public User findByName(String name) {
		final List<User> list = em.createQuery("select u from User u where u.username = :name", User.class).setParameter("name",
				name).getResultList();
		return returnSingleOrNull(list);
	}

}
