package auction.service;

import auction.dao.ItemDAO;
import auction.model.Bid;
import auction.model.Item;
import com.jboss.transactions.Transactional;

import javax.inject.Inject;

/**
 * @author Sebastian Hennebrueder
 */
public class AuctionServiceImpl implements AuctionService {
	private ItemDAO itemDAO;


	@Inject
	public AuctionServiceImpl(ItemDAO itemDAO) {
		this.itemDAO = itemDAO;
	}

	@Override
	@Transactional
	public void create(Item item) {
		itemDAO.persistent(item);
	}

	@Override @Transactional
	public void placeBid(Bid bid) {
		// just make sure that bid is added to collection as well
		bid.getItem().addBid(bid);
		// cascading will save the bid
		itemDAO.merge(bid.getItem());
	}
}
