package auction.service;

import auction.dao.UserDAO;
import auction.model.User;
import com.jboss.transactions.Transactional;
import org.hibernate.Hibernate;

import javax.inject.Inject;
import java.util.List;

/**
 * @author Sebastian Hennebrueder
 */
public class UserServiceImpl implements UserService {
	private UserDAO userDAO;

	@Inject
	public UserServiceImpl(UserDAO userDAO) {
		this.userDAO = userDAO;
	}

	@Override @Transactional
	public User findByName(String name) {
		return userDAO.findByName(name);
	}

	@Override @Transactional
	public User findById(Long id, boolean lock) {
		return userDAO.findById(id, lock);
	}

	@Override @Transactional
	public User findByIdInitializeItems(long id, boolean lock) {
		final User user = userDAO.findById(id, lock);
		Hibernate.initialize(user.getItemsForSale());
		return user;
	}

	@Override @Transactional
	public List<User> findAll() {
		return userDAO.findAll();
	}

	@Override @Transactional
	public void save(User user) {
		userDAO.persistent(user);
	}
}
